unit Z19_2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

const
  Chars: set of Char = ['A'..'Z', 'a'..'z', '', '','','','','','','','','','', '', '', '', '',
    '','','','','','','','','','','','','','',''];

type
  TController = class(TThread)
  private
    CharInProgress: LongWord;
    TextInProgress: string;
    InputLength: LongWord;
    WordInProgress: string;
  protected
    procedure Correct;
    procedure Execute; override;
    procedure Update;
  public
    InputText: TStrings;
    OutputText: string;
    Dictonary: string;
    Parent: TForm;
  end;

implementation

uses Z19_3, Z19_5;

{ TController }

procedure TController.Correct;
begin
  with TForm1.Create(Application) do try
    SelStart := CharInProgress - Length(WordInProgress) - 1;
    SelLength := Length(WordInProgress);
    RichEdit1.Lines.Text := TextInProgress;
    RichEdit1.SelStart := SelStart;
    RichEdit1.SelLength := SelLength;
    RichEdit1.SelAttributes.Color := clRed;
    RichEdit1.SelAttributes.Style := [fsBold];
    Edit1.Text := WordInProgress;
    case ShowModal of
      mrOK: begin
        TextInProgress := RichEdit1.Lines.Text;
        CharInProgress := CharInProgress - SelLength - 1;
        WordInProgress := '';
        InputLength := Length(TextInProgress);
      end;
      mrYes: Dictonary := Dictonary + #10#13 + WordInProgress;
      mrAbort: Terminate;
    end;
  finally
    Free;
  end;
end;

procedure TController.Execute;
begin
  CharInProgress := 1;
  TextInProgress := InputText.Text;
  InputLength := Length(TextInProgress) + 1;

  repeat

    if not (TextInProgress[CharInProgress] in Chars) then begin
      if WordInProgress <> '' then begin
        if Pos(UpperCase(WordInProgress), Dictonary) = 0 then
          Synchronize(Correct);
        OutputText := OutputText + WordInProgress;
        WordInProgress := '';
        Synchronize(Update);
      end;
      OutputText := OutPutText + TextInProgress[CharInProgress];
    end else begin
      WordInProgress := WordInProgress + TextInProgress[CharInProgress];
    end;
    CharInProgress := CharInProgress + 1;

    if CharInProgress = InputLength then Break;

  until Terminated;

  if not Terminated then Terminate;

  OutputText := TextInProgress;

end;

procedure TController.Update;
begin
  with (Parent as TVSControlForm) do begin
    pgbProgress.Position := Round((CharInProgress / InputLength) * 100);
    lblProgress.Caption := 'Hotovo: ' + IntToStr(pgbProgress.Position) + '%';
  end;
end;

end.
